function love.load()
	paddleOneY = 210
	paddleTwoY = 210
	PaddleOneSpeed = 0.75
	PaddleTwoSpeed = 1


	ballx = 3000
	bally = 3000
	ballXSpeed = 0
	ballYSpeed = 0

	leftScore = 0
	rightScore = 0
	fontSize = love.graphics.newFont(60)

	result = " "
	resultX = 640
	resultY = 360
	resultSize = love.graphics.newFont(100)

	buttonx = love.graphics.getWidth() / 2
	buttony = love.graphics.getHeight() / 2

	ballAlpha = 0

	titleSize = love.graphics.newFont(50)

	reactionX = 640

	lineAlpha = 0
end

function love.update(dt)
	UP()
	DOWN()
	BALLBOUNCE()
	BOUNDARIES()
	COLLISION()
	AI()
	RESPAWN()
	SCORE()
	RESULT()
	RESTART()
	QUIT()
	love.mousepressed(x, y, button)
end

function love.draw()
	love.graphics.setColor(26, 152, 53, lineAlpha)
	love.graphics.rectangle("fill", 635, 0, 10, 720)
	
	love.graphics.setColor(255, 255, 255, 255)	
	love.graphics.rectangle("fill", 20, paddleOneY, 20, 250)
	love.graphics.rectangle("fill", 1240, paddleTwoY, 20, 250)
	love.graphics.setColor(255, 255, 255, ballAlpha)
	love.graphics.arc("fill", ballx, bally, 15, 0, math.pi * 2)

	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.setFont(fontSize)
	love.graphics.print(leftScore, 50, 20)
	love.graphics.print(rightScore, 1190, 20)

	love.graphics.setFont(resultSize)
	love.graphics.print(result, resultX, resultY)

	love.graphics.setFont(titleSize)
	love.graphics.print("Harrison's Pong", 430, 10)

	--BUTTONS
	love.graphics.setColor(255, 255, 255, 255)
	love.graphics.setFont(fontSize)
	love.graphics.print("EASY", buttonx - 75, buttony - 125)
	love.graphics.rectangle("line", buttonx - 100, buttony - 130, 200, 80)
	love.graphics.print("NORMAL", buttonx - 130, buttony - 35)
	love.graphics.rectangle("line", buttonx - 150, buttony - 40, 300, 80)
	love.graphics.print("HARD", buttonx - 85, buttony + 55)
	love.graphics.rectangle("line", buttonx - 100, buttony + 50, 200, 80)
end

function UP()
	if love.keyboard.isDown('up') or love.keyboard.isDown('left') then
		paddleOneY = paddleOneY - PaddleOneSpeed
	end
end

function DOWN()
	if love.keyboard.isDown('down') or love.keyboard.isDown('right') then
		paddleOneY = paddleOneY + PaddleOneSpeed
	end
end

function BALLBOUNCE()
	ballx = ballx + ballXSpeed
	bally = bally + ballYSpeed
	if bally + 15 == 720 or bally - 15 == 0 then
		ballYSpeed = -ballYSpeed
	end
end

function BOUNDARIES()
	--PADDLE ONE
	if paddleOneY < 0 then
		paddleOneY = 0
	end
	if paddleOneY + 250 > 720 then
		paddleOneY = 470
	end

	--PADDLE TWO
	if paddleTwoY < 0 then
		paddleTwoY = 0
	end
	if paddleTwoY + 250 > 720 then
		paddleTwoY = 470
	end
end

function COLLISION()
	--PADDLE ONE
	if ballx - 15 == 40 and bally <= paddleOneY + 250 and bally >= paddleOneY then
		ballXSpeed = -ballXSpeed
	end

	--PADDLE TWO
	if ballx + 15 == 1240 and bally <= paddleTwoY + 250 and bally >= paddleTwoY then
		ballXSpeed = -ballXSpeed
	end
end

function AI()
	if bally <= paddleTwoY and ballx >= reactionX then
		paddleTwoY = paddleTwoY - PaddleTwoSpeed
	end
	if bally >= paddleTwoY + 250 and ballx >= reactionX then
		paddleTwoY = paddleTwoY + PaddleTwoSpeed
	end
end

function RESPAWN()
	if ballx - 16 > love.graphics.getWidth() or ballx + 16 < 0 then
		ballx = love.graphics.getWidth() / 2
		bally = love.graphics.getHeight() / 2
	end 
end

function SCORE()
	if ballx - 15 > love.graphics.getWidth() then
		leftScore = leftScore + 1
	end
	if ballx + 15 < 0 then
		rightScore = rightScore + 1
	end
end

function RESULT()
	if leftScore == 5 or rightScore == 5 then
		ballXSpeed = 0
		ballYSpeed = 0
		ballx = love.graphics.getWidth() / 2
		bally = love.graphics.getHeight() / 2
		if leftScore == 5 then
			resultX = 400
			result = "YOU WIN!"
			ballAlpha = 0
		end
		if rightScore == 5 then
			resultX = 350
			result = "YOU LOSE!"
			ballAlpha = 0
		end
	end
end

function RESTART()
	if rightScore == 5 and love.keyboard.isDown('r') or rightScore == 5 and love.keyboard.isDown(' ') then
		ballXSpeed = 1
		ballYSpeed = 1

		leftScore = 0
		rightScore = 0
		
		result = " "
		resultX = 640
		resultY = 360
		
		paddleOneY = 210
		paddleTwoY = 210
		ballAlpha = 255
	end
	if  leftScore == 5 and love.keyboard.isDown('r') or leftScore == 5 and love.keyboard.isDown(' ') then
		ballXSpeed = 1
		ballYSpeed = 1

		leftScore = 0
		rightScore = 0
		
		result = " "
		resultX = 640
		resultY = 360

		paddleOneY = 210
		paddleTwoY = 210
		ballAlpha = 255
	end
end

function love.mousepressed(x, y, button)
	if button == "l" and x >= buttonx - 100 and x <= buttonx + 100 and y <= buttony - 50 and y >= buttony - 130 then
		ballXSpeed = 1
		ballYSpeed = 1
		PaddleTwoSpeed = 0.75
		ballx = love.graphics.getWidth() / 2
		bally = love.graphics.getHeight() / 2
		ballx = ballx + ballXSpeed
		bally = bally + ballYSpeed
		leftScore = 0
		rightScore = 0
		paddleOneY = 210
		paddleTwoY = 210

		buttonx = 3000
		buttony = 3000

		ballAlpha = 255
		lineAlpha = 255
	end
	if button == "l" and x >= buttonx - 150 and x <= buttonx + 150 and y <= buttony + 40 and y >= buttony - 40 then
		ballXSpeed = 1
		ballYSpeed = 1
		PaddleTwoSpeed = 0.95
		ballx = love.graphics.getWidth() / 2
		bally = love.graphics.getHeight() / 2
		ballx = ballx + ballXSpeed
		bally = bally + ballYSpeed
		leftScore = 0
		rightScore = 0
		paddleOneY = 210
		paddleTwoY = 210

		buttonx = 3000
		buttony = 3000

		ballAlpha = 255
		reactionX = 550
		lineAlpha = 255
	end
	if button == "l" and x >= buttonx - 100 and x <= buttonx + 100 and y <= buttony + 130 and y >= buttony + 50 then
		ballXSpeed = 1
		ballYSpeed = 1
		PaddleTwoSpeed = 2
		ballx = love.graphics.getWidth() / 2
		bally = love.graphics.getHeight() / 2
		ballx = ballx + ballXSpeed
		bally = bally + ballYSpeed
		leftScore = 0
		rightScore = 0
		paddleOneY = 210
		paddleTwoY = 210

		buttonx = 3000
		buttony = 3000

		ballAlpha = 255
		lineAlpha = 255
	end
end

function QUIT()
	if love.keyboard.isDown('escape') then
		love.event.quit()
	end
end